# - Try to find the LIBIGL library
# Once done this will define
#
#  LIBIGL_FOUND - system has LIBIGL
#  LIBIGL_INCLUDE_DIR - the LIBIGL include directory
#  LIBIGL_SOURCES_DIR - the LIBIGL source files


if(LIBIGL_INCLUDE_DIR AND LIBIGL_SOURCES_DIR)
   set(LIBIGL_FOUND TRUE)
else(LIBIGL_INCLUDE_DIR AND LIBIGL_SOURCES_DIR)

FIND_PATH(LIBIGL_SOURCES_DIR include/igl/readOBJ.h
   /usr
   /usr/local
   $ENV{LIBIGLROOT}
   $ENV{LIBIGL_ROOT}
   $ENV{LIBIGL_DIR}
   $ENV{LIBIGL_DIR}
   $ENV{DevLibraries}/libigl
   ${PROJECT_SOURCE_DIR}/../libs/libigl/
)

message(STATUS "${LIBIGL_SOURCES_DIR}")

FIND_PATH(LIBIGL_INCLUDE_DIR igl/readOBJ.h
   /usr/include
   /usr/local/include
   $ENV{LIBIGLROOT}/include
   $ENV{LIBIGL_ROOT}/include
   $ENV{LIBIGL_DIR}/include
   $ENV{LIBIGL_DIR}/inc
   $ENV{DevLibraries}/libigl/include
   ${PROJECT_SOURCE_DIR}/../libs/libigl/
   ${PROJECT_SOURCE_DIR}/../libs/libigl/include
)

message(STATUS "${LIBIGL_INCLUDE_DIR}")

if(LIBIGL_INCLUDE_DIR)
   set(LIBIGL_FOUND TRUE)
#   add_definitions(-DIGL_HEADER_ONLY)
   file(GLOB IGL_VIEWER_SOURCES
      ${LIBIGL_INCLUDE_DIR}/xml/*.cpp
   )
endif(LIBIGL_INCLUDE_DIR)

if(LIBIGL_FOUND)
   if(NOT LIBIGL_FIND_QUIETLY)
      message(STATUS "Found LIBIGL: ${LIBIGL_INCLUDE_DIR}")
   endif(NOT LIBIGL_FIND_QUIETLY)
else(LIBIGL_FOUND)
   if(LIBIGL_FIND_REQUIRED)
      message(FATAL_ERROR "could NOT find LIBIGL")
   endif(LIBIGL_FIND_REQUIRED)
endif(LIBIGL_FOUND)

MARK_AS_ADVANCED(LIBIGL_INCLUDE_DIR LIBIGL_LIBRARIES IGL_VIEWER_SOURCES)

endif(LIBIGL_INCLUDE_DIR AND LIBIGL_SOURCES_DIR)

